//----------------------------------------------------------------------------------------------

// PasteJob.cp

//----------------------------------------------------------------------------------------------

/*



*/

#include "PasteJob.h"
#include "CopyUtils.h"
#include "OpenClipDefines.h"

//----------------------------------------------------------------------------------------------

PasteJob::PasteJob(DWindow *TheWndw)
  : mTheWndw(TheWndw),
    //mPgSzY(),
    mSourceScale(1.0),
    mDestScale(1.0),
    mScaleFactor(1.0),
    mNbrFound(0),
    mTheList()
{
  //CDPoint PgSz = TheWndw->pageSize;
  //mPgSzY = PgSz.y;
  //UnitRec TheUnits = TheWndw->GetUnits();
  //mDestScale = TheUnits.Scale();

};


void PasteJob::AppendToOurList(PDObject TheObj)
{

  //TheObj.SetChanged();  // PowerCADD stuff
  //TheObj.Bounds();
  //TheObj.Extents();
  //SelObject(&TheObj);
  //AppendObj(TheObj,mTheList);
  
  mNbrFound++;
};


bool PasteJob::GetScale(NSDictionary *TheDict,double &theScale) const
{
  bool Result = false;
  
  NSNumber *nScale = [TheDict objectForKey:OpenClip_DrawingScale];
  
  if (nScale) {
    theScale = [nScale doubleValue];
    Result = true;
  };
  
  return Result;
};

/*
bool PasteJob::GetGlobalOrigin(NSDictionary *TheDict,CDPoint &theOrigin) const
{
  bool Result = false;
  
  NSDictionary *PtDict = [TheDict objectForKey:OpenClip_GlobalOrigin];

  if (PtDict) {
    NSNumber *nX = [PtDict objectForKey:OpenClip_X];
    NSNumber *nY = [PtDict objectForKey:OpenClip_Y];
    
    if (nX && nY) {
      theOrigin.x = [nX doubleValue];
      theOrigin.y = [nY doubleValue];
      Result = true;
    };
    
  };
      
  return Result;
};
*/
/*
bool PasteJob::GetInsertionPoint(NSDictionary *TheDict,CDPoint &thePt) const
{
  bool Result = false;
  
  NSDictionary *PtDict = [TheDict objectForKey:OpenClip_InsertionPoint];
  
  if (PtDict) {
    NSNumber *nX = [PtDict objectForKey:OpenClip_X];
    NSNumber *nY = [PtDict objectForKey:OpenClip_Y];
    
    if (nX && nY) {
      thePt.x = [nX doubleValue];
      thePt.y = [nY doubleValue];
      Result = true;
    };
    
  };  
  
  return Result;
};
*/
/*
bool PasteJob::GetLayerName(NSDictionary *TheNSLayer,NSString *TheLayerName) const
{
  bool Result = false;
  
  TheLayerName = [TheNSLayer objectForKey:OpenClip_LayerName];
  
  if (TheLayerName)
    Result = true;
  
  return Result;
};
*/
/*
bool PasteJob::GetLayerColor(NSDictionary *TheNSLayer,RGBColor &TheLayerColor) const
{
  bool Result = false;
  
  NSDictionary *TheColor = [TheNSLayer objectForKey:OpenClip_LayerColor];
  
  double   Alpha;
  
  if (GetAColor(TheColor, TheLayerColor, Alpha))
    Result = true;
  
  return Result;
};
*/
/*
bool PasteJob::GetLayerScale(NSDictionary *TheNSLayer,double &TheLayerScale) const
{
  bool Result = false;
  
  NSNumber *nTheScale = [TheNSLayer objectForKey:OpenClip_LayerScale];
  
  if (nTheScale) {
    TheLayerScale = [nTheScale doubleValue];
    Result = true;
  };
  
  return Result;
};
*/

CDPoint PasteJob::CorrectPoint(CDPoint ThePt) const
{
//  ThePt.y = mPgSzY - ThePt.y;  // PowerCADD has the origin at the top left of the window
//                               // with positive Y values going down
  ThePt.x *= mScaleFactor;
  ThePt.y *= mScaleFactor;
  return ThePt;
};


bool PasteJob::Get2DPoint(NSArray *Points,long theIndex,CDPoint &thePt) const
{
  bool Result = false;
  
  long LastN = [Points count] - 1;
  
  if (theIndex <= LastN) {
    NSDictionary *PtDict = [Points objectAtIndex:theIndex];
    
    if (PtDict) {
      NSNumber *nX = [PtDict objectForKey:OpenClip_X];
      NSNumber *nY = [PtDict objectForKey:OpenClip_Y];
      
      if (nX && nY) {
        thePt.x = [nX doubleValue];
        thePt.y = [nY doubleValue];
        Result = true;
      };
      
    };
  
  };
  
  return Result;
};

/*
bool PasteJob::GetAColor(NSDictionary *TheColor,RGBColor &TheRGBColor,double &Alpha) const
{
  bool GotColor = false;
  
  if (TheColor) {
    NSNumber *nR = [TheColor objectForKey:OpenClip_Red];
    NSNumber *nG = [TheColor objectForKey:OpenClip_Green];
    NSNumber *nB = [TheColor objectForKey:OpenClip_Blue];
    NSNumber *nA = [TheColor objectForKey:OpenClip_Alpha];
    
    if (nR && nG && nB && nA) {
      float R = [nR floatValue];
      float G = [nG floatValue];
      float B = [nB floatValue];
      float A = [nA floatValue];
      
      TheRGBColor.red   = (unsigned short)(R * 65535.0);
      TheRGBColor.green = (unsigned short)(G * 65535.0);
      TheRGBColor.blue  = (unsigned short)(B * 65535.0);
      Alpha = A;
      
      GotColor = true;
    }
    
  };
  
  return GotColor;
};
*/
/*
void PasteJob::GetPenColor(NSDictionary *TheObj,PDObject &ThisObj) const
{
  NSDictionary *TheColor = [TheObj objectForKey:OpenClip_PenColor];
  
  RGBColor ThePenColor;
  double   Alpha;
  
  if (GetAColor(TheColor, ThePenColor, Alpha)) {
    CCMColorRef ThePenColorRef = new CCMColor(ThePenColor);
    ThisObj.SetPenColor(ThePenColorRef);
    ThisObj.SetPenAlpha(Alpha);
  };
  
  ThisObj.SetPenPattern(kBlackPat());
};
*/
/*
void PasteJob::GetFillColor(NSDictionary *TheObj,PDObject &ThisObj) const
{
  NSDictionary *TheColor = [TheObj objectForKey:OpenClip_FillColor];
  
  RGBColor TheFillColor;
  double   Alpha;
  
  if (GetAColor(TheColor, TheFillColor, Alpha)) {
    CCMColorRef TheFillColorRef = new CCMColor(TheFillColor);
    ThisObj.SetFillColor(TheFillColorRef);
    ThisObj.SetFillPattern(kBlackPat());
    ThisObj.SetFillAlpha(Alpha);
  }
  else
    ThisObj.SetFillPattern(kNonePat());
  
};
*/     
/*
void PasteJob::GetLineDash(NSDictionary *TheObj,PDObject &ThisObj) const
{ 
  NSArray *Dashes = [TheObj objectForKey:OpenClip_LineDash];
  
  if (Dashes) {
    long TheCount = [Dashes count];
    long LastN = TheCount - 1;
    
    TDashedLine DL;
    DL.SetLastIndex(LastN);
    
    for (long N = 0; N <= LastN; N++) {
      NSNumber *nDashLength = [Dashes objectAtIndex:N];
      double DashLength = [nDashLength floatValue];
      
      DL.SetDash(N,DashLength);
    };
    
    TDashedLineRef TheDashRef = new TDashedLine(DL);
    ThisObj.SetDash(TheDashRef);
  };
  
};
*/
/*
void PasteJob::GetPenSize(NSDictionary *TheObj,PDObject &ThisObj) const
{
  float PenSize = 1;
  
  NSNumber *nTheSize = [TheObj objectForKey:OpenClip_PenSize];
  
  if (nTheSize)
    PenSize = [nTheSize floatValue];
  
  ThisObj.SetPenSize(PenSize);
};
*/

double PasteJob::RotationAngle(NSDictionary *TheObj) const
{
  double TheAngle = 0.0;
  
  NSNumber *nTheAngle = [TheObj objectForKey:OpenClip_RotationAngle];
  
  if (nTheAngle)
    TheAngle = [nTheAngle doubleValue];
  
  return TheAngle;
};


bool PasteJob::GetStartAngle(NSDictionary *TheObj,double &TheAngle) const
{
  bool Result = false;
  
  NSNumber *nTheAngle = [TheObj objectForKey:OpenClip_StartAngle];
  
  if (nTheAngle) {
    TheAngle = [nTheAngle doubleValue];
    Result = true;
  };
  
  return Result;
};


bool PasteJob::GetArcAngle(NSDictionary *TheObj,double &TheAngle) const
{
  bool Result = false;
  
  NSNumber *nTheAngle = [TheObj objectForKey:OpenClip_ArcAngle];
  
  if (nTheAngle) {
    TheAngle = [nTheAngle doubleValue];
    Result = true;
  };
  
  return Result;
};


double PasteJob::CornerRadius(NSDictionary *TheObj) const
{
  double TheRadius = 0.0;
  
  NSNumber *nTheRadius = [TheObj objectForKey:OpenClip_CornerRadius];
  
  if (nTheRadius)
    TheRadius = [nTheRadius doubleValue];
  
  return TheRadius;
};

/*
bool PasteJob::ObjectClosed(NSDictionary *TheObj) const
{
  bool Closed = false;
  
  NSNumber *nClosed = [TheObj objectForKey:OpenClip_Closed];
  
  if (nClosed)
    Closed = [nClosed boolValue];
  
  return Closed;
};
*/
/*
bool PasteJob::GetArrowFromLine(NSDictionary *TheObj,CLineEndType &TheArrow) const
{
  bool Result = false;
  
  NSArray *Points = [TheObj objectForKey:OpenClip_Points];
  
  if (Points) {
    CDPoint A;
    CDPoint B;
    
    if (Get2DPoint(Points,0, A) && Get2DPoint(Points,1, B)) {
      TheArrow.SetLocation(A);
	    TheArrow.SetEndType(slashType);
      
      //short Misc = 0;
      
      //if the slash pen size > 1.5 the object's pen size, then set it to be thick
      
      Result = true;
    };
    
  };
  
  return Result;
};
*/
/*
bool PasteJob::GetArrowFromEllipse(NSDictionary *TheObj,CLineEndType &TheArrow) const
{
  bool Result = false;
  
  NSArray *Points = [TheObj objectForKey:OpenClip_Points];
  
  if (Points) {
    CDPoint A;
    
    if (Get2DPoint(Points,0, A)) {
      A.x = 0.0;
      TheArrow.SetLocation(A);
	    TheArrow.SetEndType(circleType);
      
      short Misc = 0;
      
      NSDictionary *TheColor = [TheObj objectForKey:OpenClip_FillColor];
  
      RGBColor TheFillColor;
      double   Alpha;
  
      if (GetAColor(TheColor, TheFillColor, Alpha)) {
        BSet( Misc,cEndFilled);
      };
      
      TheArrow.SetExtraInfo(Misc);
      Result = true;
    };
    
  };
  
  return Result;
};
*/
/*
bool PasteJob::GetArrowFromPolygon(NSDictionary *TheObj,CLineEndType &TheArrow) const
{
  bool Result = false;
  
  NSArray *Points = [TheObj objectForKey:OpenClip_Points];
  
  if (Points) {
    CDPoint A;
    
    if (Get2DPoint(Points,0, A)) {
      A.x = abs(A.x);
      TheArrow.SetLocation(A);
      TheArrow.SetEndType(arrowType);
      
      short Misc = 0;
      
      if (ObjectClosed(TheObj))
        BSet( Misc,cEndFilled);
      
      TheArrow.SetExtraInfo(Misc);
      
      //bool IsFilled = BTst(Misc,cEndFilled);
      //bool IsThick  = BTst(Misc,cEndThick);
      //bool IsCurved = BTst(Misc,cEndCurved);
      
      Result = true;
    };
    
  };
  
  return Result;
};
*/
/*
bool PasteJob::GetArrowFromBezier(NSDictionary *TheObj,CLineEndType &TheArrow) const
{
  bool Result = false;
  
  NSArray *Points = [TheObj objectForKey:OpenClip_Points];
  
  if (Points) {
    CDPoint A;
    
    if (Get2DPoint(Points,0, A)) {
      A.x = abs(A.x);
      TheArrow.SetLocation(A);
      TheArrow.SetEndType(arrowType);
      
      short Misc = 0;
      BSet( Misc,cEndCurved);
      
      if (ObjectClosed(TheObj))
        BSet( Misc,cEndFilled);
        
	    TheArrow.SetExtraInfo(Misc);
      
      //bool IsFilled = BTst(Misc,cEndFilled);
      //bool IsThick  = BTst(Misc,cEndThick);
      //bool IsCurved = BTst(Misc,cEndCurved);
      
      Result = true;
    };
    
  };
  
  return Result;
};
*/
/*
bool PasteJob::GetArrowsFromList(NSArray *TheNSList,CLineEndType &TheArrow) const
{
  bool Result = false;
  
  NSEnumerator *e = [TheNSList objectEnumerator];
  
  NSDictionary *TheObj;
  while ((TheObj = [e nextObject])) {
    
    NSString *nType = [TheObj objectForKey:OpenClip_ObjectType];
    
    if (nType) {
      
      if ([nType isEqualToString:OpenClip_LineObj])
        Result = GetArrowFromLine(TheObj, TheArrow);
      else if ([nType isEqualToString:OpenClip_EllipseObj])
        Result = GetArrowFromEllipse(TheObj, TheArrow);
      else if ([nType isEqualToString:OpenClip_PolygonObj])
        Result = GetArrowFromPolygon(TheObj, TheArrow);
      else if ([nType isEqualToString:OpenClip_BezierObj])
        Result = GetArrowFromBezier(TheObj, TheArrow);
      
    };

  };
  
  return Result;
};
*/
/*
void PasteJob::GetArrows(NSDictionary *TheObj,PDObject &ThisObj) const
{  
  NSArray *Arrows = [TheObj objectForKey:OpenClip_Arrows];
  
  if (Arrows) {
    
    CLineEndType Arrow1;
    
    if (GetArrowsFromList(Arrows, Arrow1)) {
      CLineEndTypeRef TheArrowRef = new CLineEndType(Arrow1);
      ThisObj.SetArrowAtStart(true);
      ThisObj.SetArrowAtEnd(true);
      ThisObj.SetArrow1(TheArrowRef);
      ThisObj.SetArrow2(TheArrowRef);
    };

  }
  else {
    NSArray *StartArrows = [TheObj objectForKey:OpenClip_ArrowAtStart];
    
    if (StartArrows) {
      
      CLineEndType Arrow1;
      
      if (GetArrowsFromList(StartArrows, Arrow1)) {
        CLineEndTypeRef TheArrowRef = new CLineEndType(Arrow1);
        ThisObj.SetArrowAtStart(true);
        ThisObj.SetArrow1(TheArrowRef);
      };
    
    }
    else {
      NSArray *EndArrows = [TheObj objectForKey:OpenClip_ArrowAtEnd];
      
      if (EndArrows) {
        
        CLineEndType Arrow2;
        
        if (GetArrowsFromList(EndArrows, Arrow2)) {
          CLineEndTypeRef TheArrowRef = new CLineEndType(Arrow2);
          ThisObj.SetArrowAtEnd(true);
          ThisObj.SetArrow2(TheArrowRef);
        };
          
      };
    
    };
  
  };
  
};
*/

void PasteJob::ParsePoint(NSDictionary *TheObj)
{
  NSArray *Points = [TheObj objectForKey:OpenClip_Points];
  
  if (Points) {
    CDPoint A;
    if (Get2DPoint(Points,0, A)) {
      //A = CorrectPoint(A);
      
      PDObject ThisObj;
      InitObject( ThisObj,pointObj);
      ThisObj.SetDataPoint(A);
      
      //GetPenColor(TheObj, ThisObj);
      
      AppendToOurList(ThisObj);
    };
  
  };

};


void PasteJob::ParsePoint3D(NSDictionary *TheObj)
{
  NSArray *Points = [TheObj objectForKey:OpenClip_Points];
  
  if (Points) {

    double Z = 0; // default
    
    if (GetDrawingObjectZHeight(TheObj, Z)) {
      // the object has a Z height
    };
        
    CDPoint A;
    if (Get2DPoint(Points,0, A)) {
      //A = CorrectPoint(A);

      if (GetPointZ(Points,0, Z)) {
        //the point has a Z height
      };
      
      Z *= mScaleFactor;  // scale the Z height      
      
      PDObject ThisObj;
      InitObject( ThisObj,pointObj);
      ThisObj.SetDataPoint(A);
      
      //GetPenColor(TheObj, ThisObj);
      
      AppendToOurList(ThisObj);
    };
  
  };

};

void PasteJob::ParseLine(NSDictionary *TheObj)
{
  NSArray *Points = [TheObj objectForKey:OpenClip_Points];
  
  if (Points) {
    CDPoint A;
    CDPoint B;
    
    if (Get2DPoint(Points,0, A) && Get2DPoint(Points,1, B)) {
      //A = CorrectPoint(A);
      //B = CorrectPoint(B);
      
      PDObject ThisObj;
      InitObject( ThisObj,lineObj);
      SetLinePts(A,B, ThisObj);
      
      //GetPenColor(TheObj, ThisObj);
      //GetPenSize(TheObj, ThisObj);
      //GetLineDash(TheObj, ThisObj);
      //GetArrows(TheObj, ThisObj);
      
      AppendToOurList(ThisObj);
    };
  
  };

};


void PasteJob::ParseRectangle(NSDictionary *TheObj)
{
  NSArray *Points = [TheObj objectForKey:OpenClip_Points];
  
  if (Points) {
    CDPoint A;
    CDPoint B;
    
    if (Get2DPoint(Points,0, A) && Get2DPoint(Points,1, B)) {
      //A = CorrectPoint(A);
      //B = CorrectPoint(B);
      
      CDRect TheRect(A,B);

      double TheRadius = CornerRadius(TheObj);
      TheRadius *= mScaleFactor;
      
      double TheRotationAngle = RotationAngle(TheObj);
      
      //IMPORTANT, the center of rotation of a rectangle is the center of the rectangle
      
      PDObject ThisObj;
      
      if (TheRadius != 0.0) {
        InitObject( ThisObj,rrectObj);
        ThisObj.SetDataRect(TheRect);
        ThisObj.SetOvalRad(TheRadius * 2); // OvalRad is really a diameter
      }
      else {
        
        if (TheRotationAngle == 0.0) {
          InitObject( ThisObj,rectObj);
          ThisObj.SetDataRect(TheRect);
        }
        else {
          InitObject( ThisObj,rtRectObj);
          ThisObj.SetUnRtRect(TheRect);
          ThisObj.SetRotationAngle(Degrees2Radians(-TheRotationAngle));
        };
      
      };
      
      //GetFillColor(TheObj, ThisObj);
      //GetPenColor(TheObj, ThisObj);
      //GetPenSize(TheObj, ThisObj);
      //GetLineDash(TheObj, ThisObj);
      
      AppendToOurList(ThisObj);
    };
    
  };

};


void PasteJob::ParseEllipse(NSDictionary *TheObj)
{
  NSArray *Points = [TheObj objectForKey:OpenClip_Points];
  
  if (Points) {
    CDPoint A;
    CDPoint B;
    
    if (Get2DPoint(Points,0, A) && Get2DPoint(Points,1, B)) {
      //A = CorrectPoint(A);
      //B = CorrectPoint(B);
      
      CDRect TheRect(A,B);
      
      double StartAngle;
      double ArcAngle;
      bool IsArc = (GetStartAngle(TheObj, StartAngle) && GetArcAngle(TheObj, ArcAngle));
      
      double TheRotationAngle = RotationAngle(TheObj);
      
      //IMPORTANT, the center of rotation of an ellipse is the center of the enclosing rectangle
      
      PDObject ThisObj;
      
      if (IsArc) {
        
        if (TheRotationAngle == 0) {
          InitObject( ThisObj,arcObj);
        }
        else {
          InitObject( ThisObj,rtArcObj);
          ThisObj.SetRotationAngle(Degrees2Radians(-TheRotationAngle));
        };
        
        ThisObj.SetUnRtRect(TheRect);
        
        ThisObj.SetStartAngle(Degrees2Radians(90 - StartAngle));
        ThisObj.SetArcAngle(Degrees2Radians(-ArcAngle));
      }
      else {
        
        if (TheRotationAngle == 0) {
          InitObject( ThisObj,ovalObj);
          ThisObj.SetDataRect(TheRect);
        }
        else {
          InitObject( ThisObj,rOvalObj);
          ThisObj.SetUnRtRect(TheRect);
          ThisObj.SetRotationAngle(Degrees2Radians(-TheRotationAngle));
        };
        
      };
      
      //GetFillColor(TheObj, ThisObj);
      //GetPenColor(TheObj, ThisObj);
      //GetPenSize(TheObj, ThisObj);
      //GetLineDash(TheObj, ThisObj);
      //if (IsArc)
      //  GetArrows(TheObj, ThisObj);
      
      AppendToOurList(ThisObj);
    };
    
  };  

};


void PasteJob::ParsePolygonOrBSpline(short ObjType,NSDictionary *TheObj)
{
  NSArray *Points = [TheObj objectForKey:OpenClip_Points];
  
  if (Points) {
    PDObject ThisObj;
    InitObject( ThisObj,ObjType);
    
    long LastN = [Points count] - 1;
    
    for (long N = 0; (N <= LastN); N++) {
      CDPoint A;
      
      if (Get2DPoint(Points,N, A)) {
        //A = CorrectPoint(A);
        ThisObj.PHandle().Append(A);
      };
    
    };
    
    //bool Closed = ObjectClosed(TheObj);
    //ThisObj.SetClosed(Closed);
    
    //GetFillColor(TheObj, ThisObj);
    //GetPenColor(TheObj, ThisObj);
    //GetPenSize(TheObj, ThisObj);
    //GetLineDash(TheObj, ThisObj);
        
    //if (! Closed)
    //  GetArrows(TheObj, ThisObj);
    
    AppendToOurList(ThisObj);
  };

};


void PasteJob::ParseBezier(NSDictionary *TheObj)
{
  NSArray *Points = [TheObj objectForKey:OpenClip_Points];
  
  if (Points) {
    short Step = 1;
    CDPoint B;
    CDPoint C;
    CDPoint D;
    
    PDObject ThisObj;
    
    long LastN = [Points count] - 1;
    
    for (long N = 0; (N <= LastN); N++) {
      CDPoint ThePt;
      if (Get2DPoint(Points,N, ThePt)) {
        //ThePt = CorrectPoint(ThePt);
        
        if (N == 0) {
          StartBez( ThisObj,ThePt,ThePt);
        }
        else {
            
          switch (Step) {
            case 1 : B = ThePt;
                     Step = 2;
                     break;
            case 2 : C = ThePt;
                     Step = 3;
                     break;
            case 3 : D = ThePt;
                     BezSegment(ThisObj,B,C,D);
                     Step = 1;
                     break;
          };
          
        };
      };
    };
    
    EndBez(ThisObj,D);
    
    //bool Closed = ObjectClosed(TheObj);
    //ThisObj.SetClosed(Closed);
      
    //GetFillColor(TheObj, ThisObj);
    //GetPenColor(TheObj, ThisObj);
    //GetPenSize(TheObj, ThisObj);
    //GetLineDash(TheObj, ThisObj);
    
    //if (! Closed)
    //  GetArrows(TheObj, ThisObj);
    
    AppendToOurList(ThisObj);
  };

};


void PasteJob::ParseTheAdvancedList(NSArray *TheNSList,bool &FoundObj)
{
  FoundObj = false;  // handle any special objects you know about
  
  NSEnumerator *e = [TheNSList objectEnumerator];
  
  NSDictionary *TheObj;
  while ((TheObj = [e nextObject])) {
    
    NSString *nType = [TheObj objectForKey:OpenClip_ObjectType];
    
    if (nType) {
      
      if ([nType isEqualToString:OpenClip_BSplineObj]) {
        ParsePolygonOrBSpline(smoothObj,TheObj);
        FoundObj = true;
      };
    
    };

  };

};


void PasteJob::ParseTheList(NSArray *TheNSList)
{
  NSEnumerator *e = [TheNSList objectEnumerator];
  
  NSDictionary *TheObj;
  while ((TheObj = [e nextObject])) {
    
    NSString *nType = [TheObj objectForKey:OpenClip_ObjectType];
    
    if (nType) {
      
      if ([nType isEqualToString:OpenClip_PointObj]) {
        bool FoundObj = false;
        NSArray *TheAdvancedList = [TheObj objectForKey:OpenClip_Advanced];
        if (TheAdvancedList)
          ParseTheAdvancedList(TheAdvancedList, FoundObj);
          
        ParsePoint(TheObj);
      }
      else if ([nType isEqualToString:OpenClip_LineObj]) {
        bool FoundObj = false;
        NSArray *TheAdvancedList = [TheObj objectForKey:OpenClip_Advanced];
        if (TheAdvancedList)
          ParseTheAdvancedList(TheAdvancedList, FoundObj);
          
        ParseLine(TheObj);
      }
      else if ([nType isEqualToString:OpenClip_RectObj]) {
        bool FoundObj = false;
        NSArray *TheAdvancedList = [TheObj objectForKey:OpenClip_Advanced];
        if (TheAdvancedList)
          ParseTheAdvancedList(TheAdvancedList, FoundObj);
          
        ParseRectangle(TheObj);
      }
      else if ([nType isEqualToString:OpenClip_EllipseObj]) {
        bool FoundObj = false;
        NSArray *TheAdvancedList = [TheObj objectForKey:OpenClip_Advanced];
        if (TheAdvancedList)
          ParseTheAdvancedList(TheAdvancedList, FoundObj);
          
        ParseEllipse(TheObj);
      }
      else if ([nType isEqualToString:OpenClip_PolygonObj]) {
        bool FoundObj = false;
        NSArray *TheAdvancedList = [TheObj objectForKey:OpenClip_Advanced];
        if (TheAdvancedList)
          ParseTheAdvancedList(TheAdvancedList, FoundObj);
          
        ParsePolygonOrBSpline(polyObj,TheObj);
      }
      else if ([nType isEqualToString:OpenClip_BezierObj]) {
        
        bool FoundObj = false;
        NSArray *TheAdvancedList = [TheObj objectForKey:OpenClip_Advanced];
        if (TheAdvancedList)
          ParseTheAdvancedList(TheAdvancedList, FoundObj);
        
        if (!FoundObj)
          ParseBezier(TheObj);
      
      }
      else if ([nType isEqualToString:OpenClip_GroupObj]) {
        
        NSArray *TheGroupList = [TheObj objectForKey:OpenClip_DrawingObjects];
        if (TheGroupList)
          ParseTheList(TheGroupList);
      
      };
      
    };

  };
};



void PasteJob::ParseTheLayers(NSArray *TheNSLayerList)
{
  NSEnumerator *e = [TheNSLayerList objectEnumerator];
  
  NSDictionary *TheNSLayer;
  while ((TheNSLayer = [e nextObject])) {
    //double OldSourceScale = mSourceScale;
    //double OldScaleFactor = mScaleFactor;
    
    //NSString *TheLayerName;
    //if (GetLayerName(TheNSLayer,TheLayerName)) {
    //  
    //};
    
    //RGBColor TheLayerColor;
    //if (GetLayerColor(TheNSLayer, TheLayerColor)) {
    //  
    //};
    
    //double TheLayerScale;
    //if (GetLayerScale(TheNSLayer, TheLayerScale)) {
    //  mSourceScale = TheLayerScale;
    //  mScaleFactor = mSourceScale / mDestScale;
    //};
    
    // get layer drawing objects
    NSArray *TheNSList = [TheNSLayer objectForKey:OpenClip_DrawingObjects];
    
    if (TheNSList)
      ParseTheList(TheNSList);
    
    //mSourceScale = OldSourceScale;
    //mScaleFactor = OldScaleFactor;
  };
};


void PasteJob::ReadTheDictionary(NSDictionary *TheDocument)
{
  NSAutoreleasePool *thePool = [[NSAutoreleasePool alloc] init];
  
  PDObject TheGrpObj;
  InitObject( TheGrpObj,grpObj);
  mTheList = TheGrpObj.GroupList();
        
  double TheScale;
  if (GetScale(TheDocument, TheScale)) {  // all files should have a scale
    mSourceScale = TheScale;
    mScaleFactor = mSourceScale / mDestScale;
  };
  
  //CDPoint TheOrigin;    // optional
  //if (GetGlobalOrigin(TheDocument, TheOrigin)) {
  //
  //};
  
  //CDPoint ThePt;    // optional
  //if (GetInsertionPoint(TheDocument, ThePt)) {
  //
  //};
  
  NSArray *TheNSLayerList = [TheDocument objectForKey:OpenClip_DrawingLayers];
        
  if (TheNSLayerList)
    ParseTheLayers(TheNSLayerList);
  else {
    
    NSArray *TheNSList = [TheDocument objectForKey:OpenClip_DrawingObjects];
          
    if (TheNSList)
      ParseTheList(TheNSList);
  
  };
        
  if (mNbrFound == 0) {
    RecoverObject( TheGrpObj);
  }
  else {
    
    //mTheWndw->UnselectAll();
    //mTheWndw->SetUndo(listChange);
    //SetTheObject(mTheWndw,TheGrpObj);  // add objects to the drawing
  };
  
  [thePool drain];
};


void PasteJob::ReadOpenClipFile(void)
{
  NSFileManager *fileManager = [NSFileManager defaultManager];
  NSArray *Paths = NSSearchPathForDirectoriesInDomains(NSApplicationSupportDirectory,NSLocalDomainMask,NO);
  
  if ([Paths count] > 0) {  
    NSString *destinationPath = [[Paths objectAtIndex:0] stringByAppendingPathComponent:@"OpenClip"];
    //NSLog(destinationPath); // /Library/Application Support/OpenClip
    
    if ([fileManager fileExistsAtPath:destinationPath]) {
      //NSLog(@"OpenClip Directory exists");
      
      NSString *TheFilePath = [destinationPath stringByAppendingPathComponent:@"OpenClip"];
      //NSLog(TheFilePath);  // /Library/Application Support/OpenClip/OpenClip
      
      NSFileHandle *theFileHandle = [NSFileHandle fileHandleForReadingAtPath:TheFilePath];
      
      NSDictionary *TheDocument = [NSDictionary dictionaryWithContentsOfFile:TheFilePath];
                      // [NSDictionary dictionaryWithContentsOfURL::ThePath];
      
      if (TheDocument) {
        ReadTheDictionary(TheDocument);
      }
      
      [theFileHandle closeFile];  // this is all new stuff for me
    };
    
  };

};


//----------------------------------------------------------------------------------------------